#!/usr/bin/env python
# -*- coding: utf-8 -*-

# mask contrast adjusting
# set mask transparency max and min value and adjust mask contrast

from gimpfu import *
import os, glob

def minmax(image,drawable):
    lo=0
    hi=1.0
    while hi - lo > 0.01:
        test = (lo + hi) / 2
        _, _, _, pixels, count, _ = \
            pdb.gimp_drawable_histogram(drawable,HISTOGRAM_VALUE, 0,test)
        if pixels != count:
            lo = test
        else:
            hi = test
        max = hi
    lo=0.0
    hi=1.0
    while hi - lo > 0.01:
        test=(lo + hi) / 2
        _, _, _, pixels, count, _ = \
            pdb.gimp_drawable_histogram(drawable,HISTOGRAM_VALUE, test,1.0)
        if pixels != count:
            hi = test
        else:
            lo = test
    min = lo
    #gimp.message('Min: %d, max: %d' % (min,max))
    gimp.message('input min and max value: '+ str(min) + " " + str(max))
    return min, max


def mask_contrast_adjustment_2(image, max, min, gamma):
    maxout = max / 100.0
    minout = min / 100.0
        # output min and max value
    # output error messages to ERROR CONSOLE
    pdb.gimp_message_get_handler(ERROR_CONSOLE)
    #gimp.message(str(len(image.layers)))
    pdb.gimp_image_undo_group_start(image)
    mask = \
        pdb.gimp_layer_get_mask(pdb.gimp_image_get_active_layer(image))
    # the active layer has mask?
    visible = \
        pdb.gimp_item_get_visible(pdb.gimp_image_get_active_layer(image))
    if mask != None and visible == TRUE: # if the layer is visble and has mask...
        try:
            pdb.gimp_layer_set_edit_mask\
                (pdb.gimp_image_get_active_layer(image), FALSE)
            # set mask editing mode off
            pdb.gimp_layer_set_edit_mask\
                (pdb.gimp_image_get_active_drawable(image), TRUE)
            # set mask editing mode on and make the mask active
            minin, maxin = minmax(image, mask)
                # get input min and out value from original mask
            pdb.gimp_drawable_levels(pdb.gimp_layer_get_mask\
                (pdb.gimp_image_get_active_layer(image)) ,0 ,minin, \
                        maxin, FALSE ,gamma ,minout ,maxout ,FALSE)
            # Set mask's max and min, gamma values
        except Exception, error:
            print error
    pdb.gimp_image_undo_group_end(image)
    return
register(
    "mask_contrast_adjustment_2",
    "マスク透明度の最高・最低値を設定し、コントラストを調整する",
    "マスクの透明度調整",
    "Ohnishi, Yasuo",
    "Ohnishi, Yasuo",
    "2023 Ver 0.2",
    "マスクの透明度調整...",
    "*",      # Alternately use RGB, RGB*, GRAY*, INDEXED etc.
    [
        (PF_IMAGE, "image", "input image", None),
        (PF_SLIDER, "max", "最高透明度(%)", 100.0, (0, 100, 1)),
        (PF_SLIDER, "min", "最低透明度(%)", 0.0, (0, 100, 1)),
        (PF_FLOAT, "gamma", "ガンマ調整値", 1.0),
    ],
    [],
    mask_contrast_adjustment_2, menu="<Image>/Layer/" )
main()
